typedef union {
    struct {
        TSourceLoc line;
        union {
            TString *string;
            float f;
            int i;
            bool b;
        };
        TSymbol* symbol;
    } lex;
    struct {
        TSourceLoc line;
        TOperator op;
        union {
            TIntermNode* intermNode;
            TIntermNodePair nodePair;
            TIntermTyped* intermTypedNode;
            TIntermAggregate* intermAggregate;
        };
        union {
            TPublicType type;
            TQualifier qualifier;
            TFunction* function;
            TParameter param;
            TTypeLine typeLine;
            TTypeList* typeList;
	    TAnnotation* ann;
	    TTypeInfo* typeInfo;
        };
    } interm;
} YYSTYPE;
#define	ATTRIBUTE	258
#define	CONST_QUAL	259
#define	BOOL_TYPE	260
#define	FLOAT_TYPE	261
#define	INT_TYPE	262
#define	STRING_TYPE	263
#define	FIXED_TYPE	264
#define	HALF_TYPE	265
#define	BREAK	266
#define	CONTINUE	267
#define	DO	268
#define	ELSE	269
#define	FOR	270
#define	IF	271
#define	DISCARD	272
#define	RETURN	273
#define	BVEC2	274
#define	BVEC3	275
#define	BVEC4	276
#define	IVEC2	277
#define	IVEC3	278
#define	IVEC4	279
#define	VEC2	280
#define	VEC3	281
#define	VEC4	282
#define	HVEC2	283
#define	HVEC3	284
#define	HVEC4	285
#define	FVEC2	286
#define	FVEC3	287
#define	FVEC4	288
#define	MATRIX2	289
#define	MATRIX3	290
#define	MATRIX4	291
#define	HMATRIX2	292
#define	HMATRIX3	293
#define	HMATRIX4	294
#define	FMATRIX2	295
#define	FMATRIX3	296
#define	FMATRIX4	297
#define	IN_QUAL	298
#define	OUT_QUAL	299
#define	INOUT_QUAL	300
#define	UNIFORM	301
#define	VARYING	302
#define	STRUCT	303
#define	VOID_TYPE	304
#define	WHILE	305
#define	SAMPLER1D	306
#define	SAMPLER2D	307
#define	SAMPLER3D	308
#define	SAMPLERCUBE	309
#define	SAMPLER1DSHADOW	310
#define	SAMPLER2DSHADOW	311
#define	SAMPLERRECT	312
#define	SAMPLERGENERIC	313
#define	VECTOR	314
#define	MATRIX	315
#define	REGISTER	316
#define	TEXTURE	317
#define	SAMPLERSTATE	318
#define	IDENTIFIER	319
#define	TYPE_NAME	320
#define	FLOATCONSTANT	321
#define	INTCONSTANT	322
#define	BOOLCONSTANT	323
#define	STRINGCONSTANT	324
#define	FIELD_SELECTION	325
#define	LEFT_OP	326
#define	RIGHT_OP	327
#define	INC_OP	328
#define	DEC_OP	329
#define	LE_OP	330
#define	GE_OP	331
#define	EQ_OP	332
#define	NE_OP	333
#define	AND_OP	334
#define	OR_OP	335
#define	XOR_OP	336
#define	MUL_ASSIGN	337
#define	DIV_ASSIGN	338
#define	ADD_ASSIGN	339
#define	MOD_ASSIGN	340
#define	LEFT_ASSIGN	341
#define	RIGHT_ASSIGN	342
#define	AND_ASSIGN	343
#define	XOR_ASSIGN	344
#define	OR_ASSIGN	345
#define	SUB_ASSIGN	346
#define	LEFT_PAREN	347
#define	RIGHT_PAREN	348
#define	LEFT_BRACKET	349
#define	RIGHT_BRACKET	350
#define	LEFT_BRACE	351
#define	RIGHT_BRACE	352
#define	DOT	353
#define	COMMA	354
#define	COLON	355
#define	EQUAL	356
#define	SEMICOLON	357
#define	BANG	358
#define	DASH	359
#define	TILDE	360
#define	PLUS	361
#define	STAR	362
#define	SLASH	363
#define	PERCENT	364
#define	LEFT_ANGLE	365
#define	RIGHT_ANGLE	366
#define	VERTICAL_BAR	367
#define	CARET	368
#define	AMPERSAND	369
#define	QUESTION	370

